#### R script ############################################
# Update: 2019-09-09
# File name: different_Id_procss.R 
# Keywords: get impulse response curves,  
#   using different standard I(d) process,
#
# Written by: Hiroshi Murao
#
#### first things to do 
setwd("C:/book_VAR/data_works/I2_process/R_prg")
search()

#### make time data
time <- seq(-3, 10, by = 1)

num_T <- length(time)

#### make the matrices for y's 
y0 <- matrix(0, nrow = num_T, ncol = 1)
y1 <- matrix(0, nrow = num_T, ncol = 1)
y2 <- matrix(0, nrow = num_T, ncol = 1)
y3 <- matrix(0, nrow = num_T, ncol = 1)

#### for-loop to compute impuluse response values
shock <- 1
y0[4] <- shock
y1[4] <- shock
y2[4] <- shock
y3[4] <- shock

for (t in (5:num_T)){
 y0[t] <- 0
 y1[t] <- y1[t-1]
 y2[t] <- 2*y2[t-1] - y2[t-2]
 y3[t] <- 3*y3[t-1] - 3*y3[t-2] + y3[t-3] 
}

#### end for-loop

#### make outputs 
num_T <- 10

out_y0 <- y0[3:num_T]
out_y1 <- y1[3:num_T]
out_y2 <- y2[3:num_T]
out_y3 <- y3[3:num_T]

# there are 8 values
print(out_y3)

#### prepare for a graph
x_data <- seq(-1, 6, by = 1)
y_data <- cbind(out_y0, out_y1, out_y2, out_y3)
print(x_data)
print(y_data)

x_max <- max(x_data)
y_max <- max(y_data[, 4])
y_min <- min(y_data[, 1])
print(c(y_min, y_max))

#### plot, using matplot()
plot.new()

matplot(x_data, y_data, 
type = "l", lwd = 2, col = 1, 
lty = c("dashed", "solid", "dashed", "solid"),
xlim = c(-1, (x_max+1)), 
ylim = c(-5, 30), 
xlab = "time horizon", 
ylab = "impulse response", 
main = "The impulse response curves of the standard I(d) process")

# additional information to the graph
abline(h  =  0, col  =  "gray")
text(x_max, y_data[(x_data == x_max), 1], labels = "I(0)", pos = 4)
text(x_max, y_data[(x_data == x_max), 2], labels = "I(1)", pos = 3)
text(x_max, y_data[(x_data == x_max), 3], labels = "I(2)", pos = 4)
text(x_max, y_data[(x_data == x_max), 4], labels = "I(3)", pos = 4)
# pos = 1: below,  pos = 2: left,  pos = 3: up,  pos = 4: right

#### save the graph as a file
# dev.copy(jpeg, file  =  "./outputs/I0-I3_process.jpg")
# dev.off()

#### end #########################################################