#### R script ########################################
# Last modfied: 2019-09-28
# File name: lagSelect_VAR.R
# Keywords: lag selection for VAR(p) 
# using VARselect() function in Package "vars",
#   
# Written by: Hiroshi Murao
#
# Purpose: Get the lag selection information for VAR(p),
#     using VARselect() function in Package "vars".
#
# Name of data set: "Canada" in Package "vars"
#
# Sample periods:  1980:1 2004:4
#
# List of variables
#
# prod : labor productivity = log of GDP - log of employment
# e : log of employment
# U : unemplyment rate
# rw : real wage = log of real wage index 
#
#### first things to do 
setwd("C:/book_VAR/data_works/Pfaff_Canada/R_prg")
library(vars)
library(urca)

#### data preparations
data(Canada)
print(Canada[1:10, ])
summary(Canada)

#### get information for lag selection, using VARselect() in Package "vars"
out_VARselect <- VARselect(y = Canada[, c("prod", "e", "U", "rw")], 
type = "both", lag.max = 8)

print(out_VARselect)

#### end #############################################
