#### R script ########################################
# Last modfied: 2019-09-09
# File name: test_egcm.R
# Keywords: cointegration test, 
#    using egcm() function in Package "egcm", 
#    Engle-Granger test,  
# 
# Written by: Hiroshi Murao
#
# Data set: "Canada" in Package "vars",
# Data type: Canadian quarterly data
# Sample periods: 1980:1 2004:4
#
# List of variables
#
# prod : labor productivity = log of GDP - log of employment
# e : log of employment
# U : unemplyment rate
# rw : real wage = log of real wage index 
#
#### first things to do 
setwd("C:/book_VAR/data_works/Pfaff_Canada/R_prg")
library(vars) # VAR
library(urca) # unit root, cointegration
library(egcm) # cointegration
search()

#### get data
# R package "vars" contains the data set "Canada" 
data(Canada)
print("The data@set of Canada")
print(Canada[1:5, ])

#### cointegration tests, using egcm() in Package "egcm"
## rw vs. prod
egcm_rw_prod <- egcm(Canada[, "rw"], Canada[, "prod"])
summary(egcm_rw_prod)
print(egcm_rw_prod)

## rw vs. e
egcm_rw_e <- egcm(Canada[, "rw"], Canada[, "e"])
print(egcm_rw_e)

## rw vs. U
egcm_rw_U <- egcm(Canada[, "rw"], Canada[, "U"])
print(egcm_rw_U)

## e vs. prod
egcm_e_prod <- egcm(Canada[, "e"], Canada[, "prod"])
print(egcm_e_prod)

## e vs. U
egcm_e_U <- egcm(Canada[, "e"], Canada[, "U"])
print(egcm_e_U)

## U vs. prod
egcm_U_prod <- egcm(Canada[, "U"], Canada[, "prod"])
print(egcm_U_prod)

#### end #############################################
