#### R script ########################################
# Last modfied: 2019-11-18
# File name: test_nomality.R
# Keywords for file name
#    test: test of normal distribution
#    normality: using normality() function in "vars"
#  
# Written by: Hiroshi Murao
#
# Purpose: perform the test of normal distribution,
#    using normality() function.  
#
# Name of data set: "Canada" in package "vars"
#
# Sample periods: 1980:1 2004:4
#
# List of variables
#
# prod : labor productivity = log of GDP - log of employment
# e : log of employment
# U : unemplyment rate
# rw : real wage = log of real wage index 
#
#### first things to do 
setwd("F:/book_VAR/data_works/Pfaff_Canada/R_prg")
library(vars)
library(urca)

#### get data
data(Canada)
print(Canada[1:10, ])

#### use VARselect()
out_VARselect <- VARselect(Canada, lag.max = 8, type = "both")  
print(out_VARselect)

#### estimate a VAR(p) model, using VAR()
out_VAR <- VAR(Canada, p = 3, type = "both")
print(out_VAR)
summary(out_VAR)

#### test of normality, using normality.test() in "vars"
normalTest_JB <- normality.test(out_VAR)
print(normalTest_JB$jb.mul)

#### end #############################################
