###### R Script ########################################
# Last modfied: 2017-09-14
# File name: F_table.R
# Keywords: statistical table of F distribution
#
# Written by: Hiroshi Murao
#
#### first things to do 
setwd("C:/book_VAR/data_works/stat_tables/R_prg")
library(vars) # VAR
library(urca) # unit root, cointegration
search()

#### chi-squared distribution, using chisq()
seq_11 <- seq(1, 5, by = 1)
seq_12 <- seq(10, 20, by = 5)
seq_13 <- c(30, 40, 60, 120)
seq_14 <- 10^9
data_df1 <- c(seq_11, seq_12, seq_13, seq_14)
print(data_df1)
num_col <- length(data_df1)
print(num_col)  # num_df1 = 13

seq_21 <- seq(1, 25, by = 1)
seq_22 <- c(30, 40, 60, 120)
seq_23 <- 10^9
data_df2 <- c(seq_21, seq_22, seq_23) # , seq_24, seq_25)
print(data_df2)
num_row <- length(data_df2)
print(num_row)  # num_df2 = 30

# data_prob = c(0.995, 0.990, 0.975, 0.950, 0.900, 0.100, 0.050, 0.025, 0.010, 0.005)
# print(data_prob)

# set the right-tail probability
prob <- 0.01
test_f <- qf(prob, df1=120, df2=10^9, lower.tail=FALSE) 
print(test_f)

f_table <- matrix(0, nrow = num_row, ncol = num_col)

count_row <- 0

#### row-loop
for (row in (1:num_row)){
  for (col in (1:num_col)){
  f_table[row, col] <- qf(prob, df1=data_df1[col], df2=data_df2[row], lower.tail=FALSE)
  } # end of col-loop
  count_row <- count_row + 1
}
#### end row-loop

print(count_row)  # count_row = 30
print(f_table)

#### prepare for final output
round_table <- matrix(0, nrow = num_row, ncol = num_col)

#### for alph=0.03
round_table[1, ] <- round(f_table[1, ], digits=0)
print(rbind(round_table[1, ], f_table[1, ]))

round_table[2, ] <- round(f_table[2, ], digits = 1)

round_table[3, 1] <- round(f_table[3, 1], digits = 1)
round_table[3, 2:num_col] <- round(f_table[3, 2:num_col], digits = 2)

#round_table[4, 1:4] <- round(f_table[4, 1:4], digits = 3)
#round_table[4, 5:10] <- round(f_table[4, 5:10], digits = 2)

#round_table[5, 1:3] <- round(f_table[5, 1:3], digits = 3)
#round_table[5, 4:10] <- round(f_table[5, 4:10], digits = 2)

#round_table[6, 1:2] <- round(f_table[6, 1:2], digits = 3)
#round_table[6, 2:10] <- round(f_table[6, 2:10], digits = 2)

#round_table[7, 1] <- round(f_table[7, 1], digits = 3)
#round_table[7, 2:10] <- round(f_table[7, 2:10], digits = 2)

#### row-loop
for (row in (4:num_row)){
  for (col in (1:num_col)){
  round_table[row, col] <- round(f_table[row, col], digits=2)
  } # end of col-loop
}
#### end of row-loop

print(round_table)

#### write data into a csv-file
#write.csv(round_table, "./temp_data/f_table_005.csv")
write.csv(round_table, "./temp_data/f_table_001.csv")

#### check the csv-data
#csv_data <- read.csv("./temp_data/f_table_005.csv")
csv_data <- read.csv("./temp_data/f_table_005.csv")
print(csv_data)
  
###### end #############################################
