###### R Script ########################################
# Last modfied: 2017-09-14
# File name: chisq_table.R
# Keywords: statistical table of chi-squared distribution
# Written by: Hiroshi Murao
#
#### first things to do 
setwd("C:/book_VAR/data_works/stat_tables/R_prg")
library(vars) # VAR
library(urca) # unit root, cointegration
search()

#### chi-squared distribution, using chisq()
seq_1 <- seq(1, 30, by = 1)
seq_2 <- seq(40, 100, by = 10)
seq_3 <- seq(150, 200, by = 50)
data_df <- c(seq_1, seq_2, seq_3)
print(data_df)
num_row <- length(data_df)
print(num_row)  # num_df = 52

data_prob = c(0.995, 0.990, 0.975, 0.950, 0.900, 0.100, 0.050, 0.025, 0.010, 0.005)
print(data_prob)
num_col <- length(data_prob)
print(num_col)  # num_col = 10

# set the right-tail probability
test_chisq <- qchisq(data_prob, df = 5, lower.tail = FALSE) 
print(test_chisq)

chisq_table <- matrix(0, nrow = num_row, ncol = num_col)

count_row <- 0

#### row-loop
for (row in (1:num_row)){
  first_pt <- (row-1)*num_col + 1
  last_pt <- row*num_col
  chisq_table[row, ] <- qchisq(data_prob, df=data_df[row], lower.tail = FALSE)
  count_row <- count_row + 1
}
#### end row-loop

print(count_row)  # count_row = 48
print(chisq_table)

#### prepare for final output
round_table <- matrix(0, nrow=num_row, ncol=num_col)

round_table[1, 1] <- round(chisq_table[1, 1], digits = 5)
round_table[1, 2] <- round(chisq_table[1, 2], digits = 5)
round_table[1, 3] <- round(chisq_table[1, 3], digits = 5)
round_table[1, 4] <- round(chisq_table[1, 4], digits = 5)
round_table[1, 5] <- round(chisq_table[1, 5], digits = 4)
round_table[1, 6:10] <- round(chisq_table[1, 6:10], digits = 2)

print(rbind(round_table[1, ], chisq_table[1, ]))

round_table[2, 1] <- round(chisq_table[2, 1], digits = 5)
round_table[2, 2:3] <- round(chisq_table[2, 2:3], digits = 4)
round_table[2, 4:5] <- round(chisq_table[2, 4:5], digits = 3)
round_table[2, 6:10] <- round(chisq_table[2, 6:10], digits = 2)

round_table[3, 1] <- round(chisq_table[3, 1], digits = 4)
round_table[3, 2:5] <- round(chisq_table[3, 2:5], digits = 3)
round_table[3, 6:10] <- round(chisq_table[3, 6:10], digits = 2)

round_table[4, 1:4] <- round(chisq_table[4, 1:4], digits = 3)
round_table[4, 5:10] <- round(chisq_table[4, 5:10], digits = 2)

round_table[5, 1:3] <- round(chisq_table[5, 1:3], digits = 3)
round_table[5, 4:10] <- round(chisq_table[5, 4:10], digits = 2)

round_table[6, 1:2] <- round(chisq_table[6, 1:2], digits = 3)
round_table[6, 3:10] <- round(chisq_table[6, 3:10], digits = 2)

round_table[7, 1] <- round(chisq_table[7, 1], digits = 3)
round_table[7, 2:10] <- round(chisq_table[7, 2:10], digits = 2)

#### row-loop
for (row in (8:num_row)){
  for (col in (1:num_col)){
  round_table[row, col] <- round(chisq_table[row, col], digits = 2)
  } # end of col-loop
}
#### end of row-loop

print(round_table)

#### write data into a csv-file
write.csv(round_table, "./temp_data/chisq_table.csv")

#### check the csv-data
csv_data <- read.csv("./temp_data/chisq_table.csv")
print(csv_data)
  
###### end #############################################
