###### R Script ########################################
# Last modfied: 2017-09-14
# File name: normal_table.R
# Keywords: statistical table of N(0,1)
#
# Written by: Hiroshi Murao
#
#### first things to do 
setwd("C:/book_VAR/data_works/stat_tables/R_prg")
library(vars) # VAR
library(urca) # unit root, cointegration
search()

#### normal distribution, using pnorm()
data_z <- seq(0.00, 3.09, by = 0.01)
num_obs <- length(data_z)
print(num_obs)

# set the upper-tail probability
# out_norm <- 1- pnorm(data_z, mean=0, sd = 1) 
out_norm <- pnorm(data_z, mean = 0, sd = 1, lower.tail = FALSE) 
print(out_norm)
 
#### put vector-data into a matrix
num_col <- 10 # since 0.01 interval
num_row <- num_obs/num_col  # 310/10 = 31
print(c(num_row, num_col))

normal_table <- matrix(0, num_row, num_col)

first_pt <- 0
last_pt <- 0
count_row <- 0

#### row-loop
for (row in (1:num_row)){
  first_pt <- (row-1)*num_col + 1
  last_pt <- row*num_col
  normal_table[row, ] <- out_norm[first_pt:last_pt]
  count_row <- count_row + 1
}
#### end row-loop

# check count_row
print(count_row)

# prepare for final output
print(normal_table)
round_table <- round(normal_table, digits = 4)
print(round_table)

#### write data into a csv-file
write.csv(round_table, "./temp_data/normal_table.csv")

#### check the csv-data
csv_data <- read.csv("./temp_data/normal_table.csv")
print(csv_data)
  
###### end #############################################
