###### R Script ########################################
# Last modfied: 2017-09-14
# File name: t_table.R
# Keywords: statistical table, t distribution
#
# Written by: Hiroshi Murao
#
#### first things to do 
setwd("C:/book_VAR/data_works/stat_tables/R_prg")
search()

#### make the data of degrees of freedom
seq_1 <- seq(1, 30, by = 1)
seq_2 <- c(40, 60, 120)
seq_3 <- 10^9
data_df <- c(seq_1, seq_2, seq_3)
print(data_df)

num_row <- length(data_df)
print(num_row)  # num_row = 39

#### make the data of probabilities
data_prob = c(0.100, 0.050, 0.025, 0.010, 0.005)
print(data_prob)
num_col <- length(data_prob)
print(num_col)  # num_col = 5

#### get the table values of t-distribution, using t() function
# test qt(), get the upper-tail probability
test_t <- qt(data_prob, df=5, lower.tail=FALSE) 
print(test_t)

t_table <- matrix(0, nrow = num_row, ncol = num_col)

count_row <- 0

#### row-loop
for (row in (1:num_row)){
  first_pt <- (row-1)*num_col + 1
  last_pt <- row*num_col
  t_table[row, ] <- qt(data_prob, df = data_df[row], lower.tail = FALSE)
  count_row <- count_row + 1
}
#### end row-loop

#### check the outputs from qt()
print(count_row)  
print(t_table)

#### prepare for final outputs 
round_table <- matrix(0, nrow = num_row, ncol = num_col)

#### row-loop
for (row in (1:num_row)){
  for (col in (1:num_col)){
  round_table[row, col] <- round(t_table[row, col], digits = 4)
  } # end of col-loop
}
#### end of row-loop

print(round_table)

#### write ouput data into a csv-file
write.csv(round_table, "./temp_data/t_table.csv")

#### check the csv-data
t_table_csv <- read.csv("./temp_data/t_table.csv")
print(t_table_csv)
  
###### end #############################################
